// Escalonador.h: interface for the Escalonador class.
//
//////////////////////////////////////////////////////////////////////
#include "linked_list.h"
#include "algorithms.h"
#include "function_objects.h"
#include <iostream>

#if !defined(AFX_ESCALONADOR_H__2ED3437E_0DB8_458E_B4CE_DA114BAD3552__INCLUDED_)
#define AFX_ESCALONADOR_H__2ED3437E_0DB8_458E_B4CE_DA114BAD3552__INCLUDED_

using namespace std;
namespace SCE {


template<class Algorith, class Process, class LIST>
class Escalonador  
{
public:
    Escalonador()
        {
        processNumber =0;
        it = lista.getIterator();
        };
    int add(Process _p)
        { 
        _p.setPid(processNumber++);
        it = _p;
        _p.print();
        return processNumber;
        }

    void terminate(int pid);


    void  execute(){
            algo(lista);
        }
    
    void print()
        {
        Process *p;
        typename LIST::Iterator first, last;
        first = lista.first();
        last = lista.last();
        do{
           (*first).print();
           first++;
           if (!first.hasNext())
               (*first).print();

           }while(first.hasNext());

        }
protected:

    Algorith algo;
    LIST lista;
    typename LIST::Iterator it;
    int processNumber;
 /*   void execute()
        {
         algo(it);

        }*/

};




class Task  
{
public:
    Task(){execTime = rand();};
    Task(int time){execTime = time;}
    void setPid(int _pid){pid=_pid;}
    int getPid(){return pid;}
    void setPrioridade(int i) {prioridade = i;}
    int getPrioridade(){return prioridade;};
    int execute(int time)
        { //return the esceeded time slice
        if (execTime < time)
            {
            time-=execTime;
            cout << "Processs pid: " << pid << " Executed: " << execTime << endl; 
            execTime=0;
            return time;
            }
        else{
            execTime-=time;
            cout << "Processs pid: " << pid << " Executed: " << time << endl ;
            return 0;
            }
        }
    void print()
        {
        cout <<"Task " <<pid << " Exectime: " << execTime << endl;
        }
    bool operator<=(Task t){
           return prioridade <= t.getPrioridade();
        }
    bool operator>(Task t){
           return prioridade > t.getPrioridade();
        }
  /*  ostream &operator*(){
        ostream output;
        output = "Task " <<pid << " Exectime: " << execTime << endl;
        return &output;

        }*/
protected:

    int pid;
    int execTime;  
    int prioridade;

};


template <class List>
class RoundRobin
{


	
public:

RoundRobin(){timeSlice= 20;}
	void operator() (List processList) 
        { 
         typename List::Iterator first, last, aux;

         while (!processList.isEmpty())
             {
                first = processList.first();
                last  = processList.last();

                do {
                     
                    if ((*first).execute(timeSlice))
		    {
			 cout << "*** Task completed: " << (*first).getPid() << endl;
			   
                         first.remove();
		    }		    
                      else                      
                          first++; 

                      if (!first.hasNext() && !processList.isEmpty())
                      {

                           if ((*first).execute(timeSlice))
			   {
				cout << "*** Task completed " << (*first).getPid() << endl;
				first.remove();
			   }		    
			   else                      
                              first++; 
                      }

                   } while (first.hasNext());
	           
             }
                    
        }

protected:

 int timeSlice;
	
};



#endif // !defined(AFX_ESCALONADOR_H__2ED3437E_0DB8_458E_B4CE_DA114BAD3552__INCLUDED_)
    }
