#ifndef _STACK_ITERATOR_H_
#define _STACK_ITERATOR_H_


namespace SCE {


/*
 * StackIterator class.
 */
template <class Container, class T>
class StackIterator
{
private:
	// pointer to the container associated with this iterator
	Container * container;

public:
	// constructor
	StackIterator()
	{
		// empty
	};
	
	// constructor
	StackIterator(Container * const _container)
	{
		container = _container;
	}
	
	// destructor 
	~StackIterator()
	{
		// empty
	};


	// returns true if there's elements to run thru still
	void setContainer(Container * const _container)
	{
		container = _container;
	}

	// returns true if there's elements to run thru still
        int hasNext() const
	{
		return !container->isEmpty();
	}


	// assignment operator
        T const & operator=(T const & value)
        {
		container->push(value);
		return value;
        }

	// dereference operator
	T const & operator*() const
	{
		return container->peek();
        }

	// prefix ++ operator
	T const & operator++()
	{
		T value;
		container->pop(value); 
		return container->peek();
	}

	// postfix ++ operator
	T const operator++(int)
	{
		T value;
		container->pop(value);
		return value;
	}
};

}  // namespace SCE

#endif  /* _STACK_ITERATOR_H_ */
